#include "branch_coverage_list.h"
/**
 * @Developed by N V Sreenivasa Rao
 * @Supervisor   Prof Pankaj Jalote
 * @URL          http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 * @title        JavaCoverage
 * @version      1.0
 */

int cmp_branch(branch_coverage_data *e1, branch_coverage_data * e2)   {
	return e1->first_index < e2->first_index;
}
linkedlist *insert_branch_coverage_list(
		linkedlist *l, int lineno, int first_index,
		int type)   {
	branch_coverage_data_ptr e;
	if(l == NULL || lineno <= 0)   {
		invalid_arg_error();
		exit(1);
	}
	e = allocate_one_element(branch_coverage_data);
	check_mem_alloc_error(e);
	e->lineno = lineno;
	e->first_index = first_index;
	e->type = type;
	return insert(l, e,(int(*)(void *, void *))&cmp_branch);
}

static void print_branch_coverage_data(branch_coverage_data * e)   {
	printf(" Lineno = %d First_index = %d Type = %d \n ", e->lineno, e->first_index, e->type);
	return;
}

void print_branch_coverage_list(linkedlist * l)   {
	printf("Branch coverage list is printing \n");
	printlist(l, (void(*)(void *))&print_branch_coverage_data);
}
