#ifndef _BRANCH_COVERAGE_LIST_H_
#define _BRANCH_COVERAGE_LIST_H_
/**
 * @Developed by N V Sreenivasa Rao
 * @Supervisor   Prof Pankaj Jalote
 * @URL          http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 * @title        JavaCoverage
 * @version      1.0
 */

/* This List is used to record about all the branches that are present
 * in the program, it also records type of branch.
 * 	TRUE  --  Means the branch is not executed which corresponds 
 * 			to truth value TRUE
 * 	FALSE --  Means the branch is not executed which corresponds
 * 			to truth value FALSE
 * 	BRANCH--  Means it is used to store about the "case statements"
 * 			and "default statements" present in a "switch"
 * 	DO_WHILE_TRUE -- Used to know the truth value of "do while construct".
 * 	CATCH_FIN_EX  -- Used to know the catch/finally statements(branches) execution.
 */

#include "linkedlist.h"

#define TRUE 1
#define FALSE 2
#define BRANCH 3
#define DO_WHILE_TRUE 4
#define CATCH_FIN_EX 5

struct branch_coverage_data   {
	int lineno;
	int first_index;
	int type;
};
typedef struct branch_coverage_data branch_coverage_data;
typedef branch_coverage_data * branch_coverage_data_ptr;

linkedlist *insert_branch_coverage_list(linkedlist *,
		int lineno, int first_index, int second_index);
void print_branch_coverage_list(linkedlist *);

linkedlist *branch_cov_list;
#endif /* _BRANCH_COVERAGE_LIST_H_ */
