#ifndef _ERROR_H_
#define _ERROR_H_
/**
 * @Developed by N V Sreenivasa Rao
 * @Supervisor   Prof Pankaj Jalote
 * @URL          http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 * @title        JavaCoverage
 * @version      1.0
 */

/* This file contains set of macros, some are used to give error messages.
 */

#include <stdio.h>

#define lineno_file_name "in Lineno = %d File = %s \n", __LINE__, __FILE__
#define print_error()  \
	fprintf(stderr, "Error " lineno_file_name);
#define mem_alloc_error()  \
	fprintf(stderr, "Memory can not be allocated " lineno_file_name)
#define invalid_arg_error()   \
	fprintf(stderr, "Invalid Argument " lineno_file_name)

#define check_mem_alloc_error(a) \
	{ if(a == NULL)  {  mem_alloc_error(); exit(1); } }

#define allocate_mem(type, count) \
	(type *)malloc(sizeof(type)*(count))
#define allocate_one_element(type) \
	(type *)malloc(sizeof(type))
#define get_element(type, l) \
	((type)l->element)
#endif
