#include "func_class_list.h"
/**
 * @Developed by N V Sreenivasa Rao
 * @Supervisor   Prof Pankaj Jalote
 * @URL          http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 * @title        JavaCoverage
 * @version      1.0
 */

int sum_of_lengths_of_fn_names = 0;
int sum_of_lengths_of_cl_names = 0;

/* Functions starts from here */

static int cmp_class(class_data *e1, class_data *e2)   {
	return 0;
}

linkedlist * insert_class_list(linkedlist *l, char *name, int file_no)   {
	class_data *e;
	e = allocate_one_element(class_data);
	check_mem_alloc_error(e);
	e->name = (char *)strdup(name);
	check_mem_alloc_error(e->name);
	e->file_number = file_no;
	sum_of_lengths_of_cl_names += strlen(name) + 3;
	return insert(l, e, (int(*)(void *, void *))&cmp_class);
}

int cmp_method(func_data *e1, func_data *e2)   {
	return e1->lb_offset < e2->lb_offset ;
}

linkedlist * insert_method_list(linkedlist *l,
			class_data_ptr cl_data, 
			char *method, 
			int start_lineno,
			int end_lineno,
			int lb_offset, 
			int rb_offset)   {
	func_data *e;
	e = allocate_one_element(func_data);
	check_mem_alloc_error(e);
	e->name = (char *)strdup(method);
	check_mem_alloc_error(e->name);
	e->start_lineno = start_lineno;
	e->end_lineno = end_lineno;
	e->lb_offset = lb_offset;
	e->rb_offset = rb_offset;
	e->c_ptr = cl_data; 
	sum_of_lengths_of_fn_names += strlen(method) + 3;
	return insert(l, e, (int(*)(void *, void *))&cmp_method);
}

static void print_class_method_element(func_data * f)   {
	printf("Function Name = %s start_lineno = %d end_lineno = %d class name = %s\n", f->name, f->start_lineno, f->end_lineno, f->c_ptr->name);
	return;
}
void print_class_method(linkedlist *l)   {
	printf("class and method list is printing \n");
	printlist(l, (void (*)(void *))&print_class_method_element);
	return;
}
