#ifndef _FUNC_CLASS_LIST_H_
#define _FUNC_CLASS_LIST_H_
/**
 * @Developed by N V Sreenivasa Rao
 * @Supervisor   Dr Pankaj Jalote
 * @URL          http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 * @title        JavaCoverage
 * @version      1.0
 */

#include "linkedlist.h"

struct class_data   {
	char *name;
	int file_number;
};
typedef struct class_data class_data;
typedef class_data * class_data_ptr;

struct func_data   {
	char *name;
	int start_lineno, end_lineno;
	int lb_offset; /* Left brace offset value */
	int rb_offset; /* Right brace offset value */
	class_data_ptr c_ptr;
};
typedef struct func_data func_data;
typedef func_data * func_data_ptr;


linkedlist * insert_class_list(linkedlist *, char *, int file_no);
linkedlist * insert_method_list(linkedlist *func_list, class_data_ptr, 
		char *, int start_lineno, int end_lineno, int lb_offset, 
		int rb_offset);
void print_class_method(linkedlist *);

/* Variables Used */
extern int sum_of_lengths_of_fn_names;
extern int sum_of_lengths_of_cl_names;
#endif /* _FUNC_CLASS_LIST_H_ */
