#include "instrument.h"
/**
 * @Developed by N V Sreenivasa Rao
 * @Supervisor   Prof Pankaj Jalote
 * @URL          http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 * @title        JavaCoverage
 * @version      1.0
 */

char *output_file = NULL;
int number_of_files = 0;
int current_file_number = 0;
int counter_of_block_list = 0;
int counter_of_branch_cvg_list = 0;
int counter_of_func_list = 0;
int base_number_of_class_list = 0;
char **file_names_list = NULL;
int **file_lineno_list = NULL;

void cp(int dest, int src, int length)   {
	char buffer[1024];
	int temp;
	while(length >= 1024)  {
		temp = read(src, buffer, 1024);
		write(dest, buffer, temp);
		length -= temp;
	}
	length = read(src, buffer, length);
	if(length != -1)
		write(dest, buffer, length);
	return;
}

void cp_till_end(int dest, int src)  {
	char buffer[1024];
	int temp;
	while((temp = read(src, buffer, 1024)) > 0)
		write(dest, buffer, temp);
	return;
}

void generate_last_file(void)   {
	int fd1;
	linkedlist * t_func_list;
	linkedlist * t_class_list;
	linkedlist * t_block_list = block_list;
	linkedlist * t_branch_cov_list = v_t_branch_cov_list;
	linkedlist * t_file_times_list = file_times_list;
	int length_of_func_list, temp;
	const char *t_code0 = "class Ds   {";
	const char t_code1[] = "static class fn_blocks_class   { static int [][] fn_blocks = {";
	const char t_code2[] = "static class fn_names_class  { static String[] fn_names =  {";
	const char t_code11[] = "\tstatic int[] class_to_file_map = {";
	const char t_code12[] = "\tstatic class cl_names_class   {  static String[] cl_names = {";
	const char t_code13[] = "\tstatic String[] file_names = {";
	const char t_code13a[] = "static String[] file_full_names = {";
	const char t_code13b[] = "static long[] mtime = {";
	const char t_code14[] = "\tstatic int[] file_linenos = {";
	const char t_code15[] = "\tstatic class statement_count_class   {static String statement_count = \"";
	const char t_code16[] = "\tstatic class block_lineno_class   { static int[][] block_lineno = {";
	const char t_code17[] = "\tstatic boolean [] cl_flags = new boolean[";
	const char t_code18[] = "\tstatic boolean [] temp_cl_flags = new boolean[";
	const char b[] = "\tstatic boolean [] fn_flags = new boolean[";
	const char t_code20[] = "\tstatic boolean [] temp_fn_flags = new boolean[";
	const char t_code21[] = "\tstatic boolean [] block_flags = new boolean[";
	const char t_code22[] = "\tstatic boolean [] temp_block_flags = new boolean[";
	const char d[] = "\tstatic int number_of_blocks = ";
	const char e[] = "\tstatic int total_number_of_statements = ";
	const char f[] = "\tstatic int total_number_of_branches = ";
	const char f1[] = "\tstatic boolean[] temp_branch_cvg_flags = new boolean[total_number_of_branches];";
	const char g[] = "\tstatic class branch_cvg_flags_class   { static int[] branch_cvg_types = {";
	const char g3[] = "\tstatic boolean []branch_cvg_flags = new boolean[total_number_of_branches];";
	const char g1[] = "\tstatic class branch_cvg_lineno_class{static int [] branch_cvg_lineno = {";
	const char g2[] = "\tstatic class branch_to_fn_map_class {static int[] branch_to_fn_map = {";
	char buffer[1024] = "";
	
	int j = 0, i = 0, k, sum = 0;
	char a[50];
	char *t1_1;
	
	fd1 = open("pack/Test.java", O_APPEND | O_RDWR);
	if(fd1 == -1)  {
		printf("File can not be opened \n");
		return;
	}
	t_func_list = v_t_func_list;
	t_class_list = v_t_class_list;
	t_block_list = v_t_block_list;
	length_of_func_list = lengthoflist(t_func_list);
	j = 0;
	t1_1 = allocate_mem(char, sum_of_lengths_of_fn_names);
	check_mem_alloc_error(t1_1);
	write(fd1, t_code0, strlen(t_code0));
	write(fd1, t_code1, strlen(t_code1));
	for( i = 0; i < length_of_func_list ; i++)   {
		k = 0;
		if( i )   {
			t1_1[j++] = ',';
			write(fd1, ",", 1); 
		}
		write(fd1, "{", 1); 
		sprintf(a, "%d", get_element(func_data *, t_func_list)->start_lineno); 
		write(fd1, a, strlen(a)); 
		write(fd1, ",", 1); 
		sprintf(a, "%d", get_element(func_data *, t_func_list)->end_lineno); 
		write(fd1, a, strlen(a)); 
		write(fd1, ",", 1); 
		sprintf(a, "%d", indexof(v_t_class_list, (void *)get_element(func_data *, t_func_list)->c_ptr) - 1);
		write(fd1, a, strlen(a)); 
		t1_1[j++] = '"';
		while(get_element(func_data *, t_func_list)->name[k] != '\0')
			t1_1[j++] = get_element(func_data *, t_func_list)->name[k++];
		t1_1[j++] = '"';
		t_func_list = t_func_list->next;
		write(fd1, "}", 1); 
	}
	write(fd1, "};}", 3);
	write(fd1, t_code2, strlen(t_code2));
	write(fd1, t1_1, j);
	write(fd1, "};}", 3);
	i = j = 0;
	t1_1 = (char *)realloc(t1_1, sizeof(char) * sum_of_lengths_of_cl_names);
	check_mem_alloc_error(t1_1);
	write(fd1, t_code11, strlen(t_code11));
	while(t_class_list->next != NULL)   {
		k = 0;
		if( i == 1)   {
			t1_1[j++] = ',';
			write(fd1, ",", 1);
		}
		i = 1;
		t1_1[j++] = '"';
		while(get_element(class_data *, t_class_list)->name[k] != '\0')
			t1_1[j++] = get_element(class_data *, t_class_list)->name[k++];
		sprintf(a, "%d", get_element(class_data *, t_class_list)->file_number);
		t_class_list = t_class_list->next;
		t1_1[j++] = '"';
		write(fd1, a, strlen(a));
	}
	write(fd1, "};", 2);
	write(fd1, t_code12, strlen(t_code12));
	write(fd1, t1_1, j);
	write(fd1, "};}", 3);
	
	write(fd1, t_code13, strlen(t_code13));
	i = 1;
	while( i < number_of_files)   {
		if ( i - 1 != 0)
			write(fd1, ",", 1);
		write(fd1, "\"", 1);
		write(fd1, file_names_list[i - 1], strlen(file_names_list[i-1]));
		write(fd1, "\"", 1);
		i++;
	}
	write(fd1, "};", 2);
	i = 0;
	write(fd1, t_code13a, strlen(t_code13a));
	while(t_file_times_list->next != NULL)   {
		if( i != 0)	
			write(fd1, ",", 1);
		i = 1;
		write(fd1, "\"", 1);
		write(fd1, get_element(file_times_data *, t_file_times_list)->file_name, 
			strlen(get_element(file_times_data *, t_file_times_list)->file_name));
		write(fd1, "\"", 1);
		t_file_times_list = t_file_times_list->next;
	}
	write(fd1, "};", 2);
	i = 0;
	t_file_times_list = file_times_list;
	write(fd1, t_code13b, strlen(t_code13b));	
	while(t_file_times_list->next != NULL)   {
		if( i != 0)
			write(fd1, ",", 1);
		i = 1;
		sprintf(a, "%ld", get_element(file_times_data *, t_file_times_list)->time);	
		write(fd1, a, strlen(a));
		t_file_times_list = t_file_times_list->next;
	}
	write(fd1, "};", 2);
	write(fd1, t_code14, strlen(t_code14));
	i = 1;
	while( i < number_of_files)   {
		if ( i - 1 != 0)
			write(fd1, ",", 1);
		sprintf(a, "%d", file_lineno_list[i - 1][0]);
		write(fd1, a, strlen(a));
		i++;
	}
	write(fd1, "};", 2);
	i = 0;
	write(fd1, t_code15, strlen(t_code15));
	j = 0;
	k = 0;
	while( v_t_stat_count_list->next != NULL)   {
		if(get_element(statement_count_data *, v_t_stat_count_list)->count < 0 || get_element(statement_count_data *, v_t_stat_count_list)->count > 9){
		get_element(statement_count_data *, v_t_stat_count_list)->count = 1;
		fprintf(stderr, "Negative statement count statement_count = %d in lineno = %d file = %s\n", get_element(statement_count_data *, v_t_stat_count_list)->count, __LINE__, __FILE__ );
		}
		sprintf(a, "%d", get_element(statement_count_data *, v_t_stat_count_list)->count);
		write(fd1, a, strlen(a));
		k++;
		sum += get_element(statement_count_data *, v_t_stat_count_list)->count;
		v_t_stat_count_list = v_t_stat_count_list->next;
	}
	write(fd1, "\";}", 3);
	write(fd1, e, strlen(e));
	sprintf(a, "%d", sum);
	write(fd1, a, strlen(a));
	write(fd1, ";\n", 2);
	strcpy(buffer, f);
	sprintf(a, "%d", temp = lengthoflist(v_t_branch_cov_list));
	strcat(buffer, a);
	strcat(buffer, ";\n");
	write(fd1, buffer, strlen(buffer));
	write(fd1, f1, strlen(f1));
	write(fd1, g, strlen(g));
	i = 0;
	while(t_branch_cov_list->next != NULL )  {
		if(i)
			write(fd1, ",", 1);
		sprintf(a, "%d", get_element(branch_coverage_data *, t_branch_cov_list)->type==DO_WHILE_TRUE ? TRUE : get_element(branch_coverage_data *, t_branch_cov_list)->type == CATCH_FIN_EX ? 4 : get_element(branch_coverage_data *, t_branch_cov_list)->type);
		write(fd1, a, strlen(a));
		t_branch_cov_list = t_branch_cov_list->next;
		i = 1;
	}
	write(fd1, "};}", 3);
	write(fd1, g3, strlen(g3));	
	write(fd1, g1, strlen(g1));
	t_branch_cov_list = v_t_branch_cov_list;
	for( i = 0; i < temp ; i++)  {
		if(i)
			write(fd1, ",", 1);
		sprintf(a, "%d", get_element(branch_coverage_data *, t_branch_cov_list)->lineno);
		write(fd1, a, strlen(a));
		t_branch_cov_list = t_branch_cov_list->next;
	}
	write(fd1, "};}", 3);
	t_branch_cov_list = v_t_branch_cov_list;
	t_func_list = v_t_func_list;
	write(fd1, g2, strlen(g2));
	j = 0;
	for( i = 0; i < temp; i++) {
		if(i)
			write(fd1, ",", 1);
		while( t_func_list->next != NULL &&  
			get_element(branch_coverage_data *, t_branch_cov_list)->lineno >= get_element(func_data *, t_func_list)->start_lineno &&
			!(get_element(branch_coverage_data *, t_branch_cov_list)->lineno >= get_element(func_data *, t_func_list)->start_lineno &&
			get_element(branch_coverage_data *, t_branch_cov_list)->lineno <= get_element(func_data *, t_func_list)->end_lineno))   {
			j++;
			t_func_list = t_func_list->next;
		}
		sprintf(a, "%d", j);
		write(fd1, a, strlen(a));
		t_branch_cov_list = t_branch_cov_list->next;
	}
	
	write(fd1, "};}", 3);
	i = lengthoflist(v_t_block_list);
	sprintf(a, "%d", i);
	strcpy(buffer, t_code21);
	strcat(buffer, a);
	strcat(buffer, "];\n");

	write(fd1, buffer, strlen(buffer));
	write(fd1, t_code22, strlen(t_code22));
	write(fd1, a, strlen(a));
	write(fd1, "];\n", 3);
	write(fd1, d, strlen(d));
	write(fd1, a, strlen(a));
	write(fd1, ";\n", 2);
	
	write(fd1, t_code16, strlen(t_code16));
	i = 0;
	t_func_list = v_t_func_list;
	t_block_list = v_t_block_list;
	j = 0;
	while(t_block_list->next != NULL)   {
		if( i == 1)
			write(fd1, ",", 1);
		else
			i = 1;
		write(fd1, "{", 1);
		sprintf(a, "%d", get_element(block_data *, t_block_list)->start_lineno);
		write(fd1, a, strlen(a));
		write(fd1, ",", 1);
		sprintf(a, "%d", get_element(block_data *, t_block_list)->end_lineno);
		write(fd1, a, strlen(a));
		while( t_func_list->next != NULL &&  
			get_element(block_data *, t_block_list)->start_lineno >=
			get_element(func_data *, t_func_list)->end_lineno &&
			!(get_element(block_data *, t_block_list)->start_lineno >= get_element(func_data *, t_func_list)->start_lineno &&
			get_element(block_data *, t_block_list)->start_lineno <= get_element(func_data *, t_func_list)->end_lineno))   {
			j++;
			t_func_list = t_func_list->next;
		}
		write(fd1, ",", 1);
		sprintf(a, "%d", j);
		write(fd1, a, strlen(a));
		write(fd1, "}", 1);
		t_block_list = t_block_list->next;
	}
	write(fd1, "};}\n", 4);
	sprintf(a, "%d", length_of_func_list);
	strcpy(buffer, b);
	strcat(buffer, a);
	strcat(buffer, "]; \n");
	write(fd1, buffer, strlen(buffer));
	write(fd1, t_code20, strlen(t_code20));
	write(fd1, a, strlen(a));
	write(fd1, "];\n", 3);
	strcpy(buffer, "\tstatic int number_of_functions = ");
	strcat(buffer, a);
	strcat(buffer, ";\n");
	write(fd1, buffer, strlen(buffer));
	strcpy(buffer, "\tstatic int number_of_classes = ");
	sprintf(a, "%d", lengthoflist(v_t_class_list));
	strcat(buffer, a);
	strcat(buffer, ";\n");
	write(fd1, buffer, strlen(buffer));
	strcpy(buffer, t_code17);
	strcat(buffer, a);
	strcat(buffer, "];\n");
	write(fd1, buffer, strlen(buffer));
	write(fd1, t_code18, strlen(t_code18));
	write(fd1, a, strlen(a));
	write(fd1, "];\n", 3);
	write(fd1, "}", 1);
	close(fd1);
}

static int isspace(char ch)   {
	return ch == ' ' || ch == '\n' || ch == '\t';
}

static char eatspace(int fd)   {
	char ch;
	do
		read(fd, &ch, 1);
	while(isspace(ch));
	return ch;
}
static int scan_till_right_parenthesis(int fd)   {
	int stack_count = 1;
	char ch;
	while(1)   {
		if(stack_count == 0)
			return lseek(fd, 0, SEEK_CUR);
		read(fd, &ch, 1);
		stack_count += ch == '('? 1: ch == ')' ? -1:0;
	}
}

int give_after_this_super(int fd, int offset)   {
	int cur_offset, result, length;
	char ch;
	char str[5];
	cur_offset = lseek(fd, 0, SEEK_CUR);
	lseek(fd, offset, SEEK_SET);
	ch = eatspace(fd);
	switch(ch)   {
	case 't':    /* for keyword this */
		length = read(fd, str, 4);
		if(length < 4)
			break;
		if(str[0] == 'h' && str[1] == 'i' && str[2] == 's' && (isspace(str[3]) || str[3] == '('))   {
			if(isspace(str[3]))
				ch = eatspace(fd);
			result = scan_till_right_parenthesis(fd);
			eatspace(fd);
			result = lseek(fd, 0, SEEK_CUR);
		}
		else
			result = offset;
		break;
	case 's':   /* for keyword super */
		length = read(fd, str, 5);
		if(length < 5)
			break;
		if(str[0] == 'u' && str[1] == 'p' && str[2] == 'e' && str[3] =='r' && (isspace(str[4]) || str[4] == '('))   {
			if(isspace(str[4]))
				ch = eatspace(fd);
			result = scan_till_right_parenthesis(fd);
			eatspace(fd);
			result = lseek(fd, 0, SEEK_CUR);
		}
		else 
			result = offset;
		break;
	default:result = offset;	
		break;
	}
	lseek(fd, cur_offset, SEEK_SET);
	return result;
}

void instrument(linkedlist *func_list, int fd)   {
	int flag = 5, offset;
	int main_flag = OFF, main_offset = 0;/* just initializing */
	extern linkedlist *class_list;
	linkedlist * t_block_list = block_list;
	linkedlist * t_branch_cov_list = branch_cov_list;
	char a[6];  /* Here powe(10, 6) is the maximum #of functions*/
	const char t[] = "pack.Test.set_fn_cvg_flag(";
	const char t2[] = "pack.Test.set_cl_cvg_flag(";
	const char t3[] = "pack.Test.set_bl_cvg_flag(";
	const char t4[] = "pack.Test.set_branch_cvg_flag(";
	const char t5[] = "try   { pack.Test.start_time = System.currentTimeMillis();";
	const char t6[] = "pack.Test.check_for_modifications();";
	const char t7[] = "} finally { pack.Test.print_result(); }";
	char buffer[1024] = "";
	struct stat *buf = NULL;
	int prev_offset = 0;
	int fd1;
	linkedlist * t_func_list;
	
	#ifdef DEBUG	
	print_branch_coverage_list(t_branch_cov_list);
	#endif
	main_offset = ((unsigned int)~0) >> 1;
	buf = allocate_one_element(struct stat);
	check_mem_alloc_error(buf);
	if(stat(output_file, buf) != -1)  {
		fprintf(stderr, "The file %s already exists\n", output_file);
		exit(0);
	}
	free(buf);
	unlink(output_file);
	fd1 = open(output_file, O_RDWR | O_CREAT, 0666);
	if(fd1 == -1)  {
		fprintf(stderr, "File can not be created \n");
		exit(0);
	}
	lseek(fd, 0, SEEK_SET);
	if(index_after_import_statements)   {
		cp(fd1, fd, index_after_import_statements);
		prev_offset = index_after_import_statements;
	}
	
	t_block_list = block_list;
	t_func_list = func_list;
	while(1)   {
		if( t_func_list->next != NULL)   {
			offset = get_element(func_data *, t_func_list)->lb_offset;
			flag = 0;
			//printf("Now for function = %s \n", temp->name);
			if(strcmp(get_element(func_data *, t_func_list)->name, "main") == 0)   {
				main_flag = ON;
				main_offset = get_element(func_data *, t_func_list)->rb_offset;
			}
		}
		if( t_branch_cov_list->next != NULL)   {
			if(flag == 5 )   {
				offset = get_element(branch_coverage_data *,t_branch_cov_list)->first_index;
				flag = 3;
			}
			else if( offset > get_element(branch_coverage_data *, t_branch_cov_list)->first_index)  {
				offset = get_element(branch_coverage_data *, t_branch_cov_list)->first_index;
				flag = 3;
			}
		}
		if(t_block_list->next != NULL)   { 
			if(flag == 5 || offset > get_element(block_data *, t_block_list)->start_index)  {
				offset = get_element(block_data *, t_block_list)->start_index;
				flag = 1; 
				t_block_list = t_block_list->next;
			}
		}
		if(main_flag && (flag == 5 || offset >= main_offset))   {
			main_flag = OFF;
			flag = 2;
			offset = main_offset;
		}
		if(flag == 5) 
			break;
		switch(flag)   {
		case 0:	
			cp(fd1, fd, offset - prev_offset);
			prev_offset = offset;
			sprintf(a, "%d", counter_of_func_list);
			counter_of_func_list++;
			strcpy(buffer, t);
			strcat(buffer, a);
			strcat(buffer, "); ");
			write(fd1, buffer, strlen(buffer));
			if(strcmp(get_element(func_data *, t_func_list)->name, "main") == 0)   {
				write(fd1, t5, strlen(t5));
				write(fd1, t6, strlen(t6));
			}
			sprintf(a, "%d", base_number_of_class_list + indexof(class_list, (void *)get_element(func_data *, t_func_list)->c_ptr) - 1);
			strcpy(buffer, t2);
			strcat(buffer, a);
			strcat(buffer, "); ");
			write(fd1, buffer, strlen(buffer));
			t_func_list = t_func_list->next;
			break;
		case 1:
			cp(fd1, fd, offset - prev_offset);
			prev_offset = offset;
			sprintf(a,  "%d", counter_of_block_list);
			counter_of_block_list++;
			strcpy(buffer, t3);
			strcat(buffer, a);
			strcat(buffer, ");");
			write(fd1, buffer, strlen(buffer));
			break;
		case 2: 
			cp(fd1, fd, offset - prev_offset - 1);
			write(fd1, t7, strlen(t7));
			prev_offset = offset - 1;
			break;
		case 3:
			cp(fd1, fd, offset - prev_offset);
			prev_offset = offset;
			sprintf(a, "%d", counter_of_branch_cvg_list);
			counter_of_branch_cvg_list++;
			strcpy(buffer, t4);
			strcat(buffer, a);
			
			if(get_element(branch_coverage_data *, t_branch_cov_list)->type != DO_WHILE_TRUE)
			
				strcat(buffer, ");");
			write(fd1, buffer, strlen(buffer));
			t_branch_cov_list = t_branch_cov_list->next;
			break;
		default:
			print_error();
			break;
		}
		flag = 5;
	}
	cp_till_end(fd1, fd);
	close(fd);
	close(fd1);
}
