#ifndef _INSTRUMENT_H_
#define _INSTRUMENT_H_
/**
 * @Developed by N V Sreenivasa Rao
 * @Supervisor   Prof Pankaj Jalote
 * @URL          http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 * @title        JavaCoverage
 * @version      1.0
 */

/* This file contains functions which are used to instrument the code.
 */ 

#include "func_class_list.h"
#include "block_list.h"
#include "branch_coverage_list.h"
#include "file_times_list.h"
#include "statement_count_list.h"
#include "error.h"
#include "extflags.h"
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>

#ifndef ON
#define ON 1
#endif
#ifndef OFF
#define OFF 0
#endif
extern int counter_of_func_list;
extern int counter_of_block_list;
extern int counter_of_branch_cvg_list;
extern int base_number_of_class_list;

extern linkedlist * v_t_class_list;
extern linkedlist * v_t_func_list;
extern linkedlist * v_t_block_list;
extern linkedlist * v_t_branch_cov_list;
extern linkedlist * v_t_stat_count_list;


char *input_file_name;
extern char *output_file;
extern char **file_names_list;
extern int **file_lineno_list;
extern int number_of_files;
extern int current_file_number;
void instrument(linkedlist *func_list, int fd);
int give_after_this_super(int fd, int offset);
void generate_last_file(void);
#endif /* _INSTRUMENT_H_ */

