#include "stack.h"
/**
 * @Developed by N V Sreenivasa Rao
 * @Supervisor   Prof Pankaj Jalote
 * @URL          http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 * @title        JavaCoverage
 * @version      1.0
 */

brace_stack_ptr initialize_brace_stack(void)   {
	brace_stack_ptr b;
	b = allocate_one_element(brace_stack);
	check_mem_alloc_error(b);
	b->fre = -1;
	return b;
}

void brace_stack_push(brace_stack_ptr b, int brace_offset, int start_lineno)   {
	if(b == NULL )   {
		invalid_arg_error();
		exit(1);
	}
	if(b->fre == MAX_BRACE_STACK_SIZE)   {
		fprintf(stderr, "Errror: stack is overflowing \n");
		exit(1);
	}
	b->brace_offset[++(b->fre)] = brace_offset;
	b->brace_start_lineno[b->fre] = start_lineno;
	return;
}

int give_top_start_lineno(brace_stack_ptr b)   {
	if(b == NULL)  {
		invalid_arg_error();
		exit(1);
	}
	if(b->fre == -1)   {
		fprintf(stderr, "Error: There is no data in the stack \n");
		exit(1);
	}
	return b->brace_start_lineno[b->fre];
}

int brace_stack_pop(brace_stack_ptr b)   {
	int brace_flag;
	if(b == NULL)  {
		invalid_arg_error();
		exit(1);
	}
	if(b->fre == -1)   {
		fprintf(stderr, "Error: There is no data in the stack \n");
		exit(1);
	}
	brace_flag = b->brace_offset[(b->fre)--];
	return brace_flag;
}
