/* Please don't modify this code. this code is used in instrumentation.
 * This tool has been developed by N V Sreenivasa Rao under the guidance of Pankaj Jalote.
 * It is freely available from 
 * http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html
 */
 
package pack;
import java.io.*;
import java.util.*;

public class Test {
	public static long start_time, time_in_execution;
	static LinkedList l_block = new LinkedList(), l_func = new LinkedList();
	static LinkedList l_class = new LinkedList(), l_branch = new LinkedList();
	static LinkedList l_time = new LinkedList();
	static FileWriter report_writer = null, html_writer = null;

	public static void set_fn_cvg_flag(int i) {
		Ds.fn_flags[i] = true;
		return;
	}
	public static void set_cl_cvg_flag(int i) {
		Ds.cl_flags[i] = true;
		return;
	}
	public static void set_bl_cvg_flag(int i) {
		Ds.block_flags[i] = true;
		return;
	}
	public static void set_branch_cvg_flag(int i) {
		Ds.branch_cvg_flags[i] = true;
		return;
	}
	public static boolean set_branch_cvg_flag(int i, boolean flag) {
		if (flag)
			Ds.branch_cvg_flags[i] = true;
		return flag;
	}
	public static synchronized void print_result() { 
		try {
			time_in_execution = System.currentTimeMillis() - start_time;
			report_writer = new FileWriter("report.dat", true);
			html_writer = new FileWriter("report.html");
			report_writer.write("=========================================================================\n");
			report_writer.write("     * * * * * * * * * * NEW SESSION * * * * * * * * * * \n");
			html_writer.write("<html><head><title>coverage report");
			html_writer.write("</title></head><body text = \"#000000\"bgcolor= \"#FFFFFF\">&nbsp;");
			html_writer.write("<blockquote><center><b>Coverage Data from IITK Java Coverage Analyzer</b></center></blockquote>");
			html_writer.write("<p><u>Coverage Achieved so far</u><br>&nbsp;");
			html_writer.write("<center><table BORDER COLS=6 WIDTH=\"100%\" NOSAVE  >");
			html_writer.write("<tr align=center nosave><td align = center nosave><b>session</b></td>");
			html_writer.write("<td nosave><b>statement</b>&nbsp;<br><b>coverage(%)</b></td>");
			html_writer.write("<td><b>branch</b>&nbsp;<br><b>coverage(%)</b></td>");
			html_writer.write("<td><b>function</b>&nbsp;<br><b>coverage(%)</b></td>");
			html_writer.write("<td><b>class</b>&nbsp;<br><b>coverage(%)</b></td>");
			html_writer.write("<td><b>time(in milliseconds)</b></td></tr>");
			read_history_for_block_coverage();
			read_history_coverage("functions_history.dat", l_func, Ds.temp_fn_flags);
			read_history_coverage("classes_history.dat", l_class, Ds.temp_cl_flags);
			read_history_coverage("branches_history.dat", l_branch, Ds.temp_branch_cvg_flags);
			print_history();
			print_fn_cvg_information();
			print_cl_cvg_information();
			print_statement_cvg_information();
			print_branch_cvg_information();
			report_writer.write("---------------------------------------\n");
			report_writer.write("The time taken in this session = " + time_in_execution + "\n");
			html_writer.write("<p>Time taken in this session is " + time_in_execution + "milliseconds");
			html_writer.write("<br><hr WIDTH=\"100%\">");
			html_writer.write("<br> The tool is freely available from ");
			html_writer.write("<a href =\"http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html\">");
			html_writer.write("http://www.cse.iitk.ac.in/users/jalote/download/javacoverage/index.html</a>");
			html_writer.write("</body></html>");
			report_writer.write("=========================================================================\n");
			report_writer.close();
			html_writer.close();
		} catch(IOException e) {
			System.out.println("Exception raised" + e);
			e.printStackTrace();
		}
	} private static void print_statement_cvg_information() throws IOException { 
		int percentage_of_blocks = 0, count_of_not_covered = 0;
		FileWriter writer1 = new FileWriter("block_history.dat", true);
		writer1.write("\n:::::\n");
		html_writer.write("<p><u>Statement Coverage achieved</u><br>&nbsp;");
		html_writer.write("<table border cols=2 width=\"100%\" nosave><tr align = center nosave><td nosave><b>File Name</b></td>");
		html_writer. write("<td><b>Blocks not Covered (Line numbers of program)</b></td></tr>");
		report_writer. write("\t    FILE \t Blocks not covered  \n");
		for (int i = 0; i < Ds.number_of_blocks; i++) {
			int j, prev_line_count, current_file_no;
			if (Ds.block_flags[i] == true)
				 writer1.write(" " + (new Integer(i).toString()) + " ");
			if (Ds.block_flags[i] == false && Ds.temp_block_flags[i] == false) {
				for (j = Ds.block_lineno_class.block_lineno[i][0]; j <= Ds.block_lineno_class.block_lineno[i][1]; j++)
					count_of_not_covered += (int) Ds.statement_count_class.statement_count.charAt(j - 1) - '0';
				if (Ds.fn_flags[Ds.block_lineno_class.block_lineno[i][2]] == true || Ds.temp_fn_flags[Ds.block_lineno_class.block_lineno[i][2]] == true) {
					current_file_no = Ds.class_to_file_map[Ds.fn_blocks_class.fn_blocks[Ds.block_lineno_class.block_lineno[i][2]][2]];
					prev_line_count = current_file_no - 1 == -1 ? 0 : Ds.file_linenos[current_file_no - 1];
					report_writer.write("\t" + Ds.file_names[current_file_no]
							    + "     " + (Ds.block_lineno_class.block_lineno[i][0] - prev_line_count)
							    + " " + (Ds.block_lineno_class.block_lineno[i][1] - prev_line_count)
							    + "\n");
					html_writer.write("<tr align = center nosave><td nosave>" + Ds.file_names[current_file_no] + "</td><td>" + (Ds.block_lineno_class.block_lineno[i][0] - prev_line_count) + "-" + (Ds.block_lineno_class.block_lineno[i][1] - prev_line_count) + "</td></tr>");
				}
			}
		}
		if (Ds.total_number_of_statements > 0)
			percentage_of_blocks = (100 - ((count_of_not_covered * 100) / Ds.total_number_of_statements));
		else
			percentage_of_blocks = 100;
		html_writer.write("</table>");
		html_writer.write("<p>Statement Coverage Achieved is " + percentage_of_blocks + "%");
		report_writer.write("STATEMENT COVERAGE ACHIEVED " + percentage_of_blocks + "%\n");
		writer1.write("% " + (new Integer(percentage_of_blocks).toString()) + " / ");
		writer1.write(new Long(time_in_execution).toString());
		writer1.close();
	} 
	private static void print_fn_cvg_information() throws IOException { 
		int percentage_of_functions = 0;
		FileWriter writer2 = new FileWriter("functions_history.dat", true);
		writer2.write("\n:::::\n");
		html_writer. write("<p><u>Function coverage achieved</u><br>&nbsp;");
		html_writer. write("<table border cols=2 width=\"100%\" nosave>");
		html_writer. write("<tr align = center nosave><td nosave><b>File Name</b></td>");
		html_writer. write("<td><b>Functions not covered</b></td></tr>");
		report_writer. write("Coverage report in this current session\n");
		int count_of_covered = 0;
		report_writer. write("\t    FILE \t\t Functions not covered   \n");
		for (int i = 0; i < Ds.number_of_functions; i++) {
			if (Ds.fn_flags[i] == true || Ds.temp_fn_flags[i] == true)
				count_of_covered++;
			if (Ds.fn_flags[i] == true)
				writer2.write(" " + (new Integer(i).toString()) + " ");
			else if (Ds.temp_fn_flags[i] == false && (Ds.cl_flags[Ds.fn_blocks_class.fn_blocks[i][2]] == true || Ds.temp_cl_flags[Ds.fn_blocks_class.fn_blocks[i][2]]
								  == true)) {
				report_writer.write("\t " + Ds.file_names[Ds.class_to_file_map[Ds.fn_blocks_class.fn_blocks[i][2]]]
						    + " \t " + Ds.fn_names_class.fn_names[i] + "\n");
				html_writer.write("<tr align = center nosave><td nosave>" + Ds.file_names[Ds.class_to_file_map[Ds.fn_blocks_class.fn_blocks[i]
															       [2]]]
						  + "</td><td>" + Ds.fn_names_class.fn_names[i] + "</td></tr>");
			}
		} percentage_of_functions = (count_of_covered * 100) / Ds.number_of_functions;
		html_writer.write("</table><p>Function Coverage Achieved is" + percentage_of_functions + "%");
		report_writer.write("FUNCTION COVERAGE ACHIEVED = " + percentage_of_functions + "%\n");
		report_writer.write("---------------------------------------\n");
		writer2.write("% " + (new Integer(percentage_of_functions).toString()));
		writer2.close();

	}
	private static void print_cl_cvg_information() throws IOException { 
		int percentage_of_classes = 0;
		FileWriter writer3 = new FileWriter("classes_history.dat", true);
		writer3.write("\n:::::\n");
		int count_of_covered = 0;
		html_writer. write("<p><u>Class Coverage Achieved</u><br>&nbsp;");
		html_writer. write("<table border cols=2 width=\"100%\" nosave>");
		html_writer. write("<tr align=center nosave><td nosave><b>File Name</b></td><td><b>Classes not Covered</b></td></tr>");
		report_writer. write("\t     FILE \t\t Classes not covered   \n");
		for (int i = 0; i < Ds.number_of_classes; i++) {
			if (Ds.cl_flags[i] == true || Ds.temp_cl_flags[i] == true)
				count_of_covered++;
			if (Ds.cl_flags[i] == true)
				writer3.write(" " + (new Integer(i).toString()) + " ");
			else if (Ds.temp_cl_flags[i] == false) {
				report_writer.write("\t " + Ds.file_names[Ds.class_to_file_map[i]] + " \t " + Ds.cl_names_class.cl_names[i] + "\n");
				html_writer.write("<tr align=center nosave><td nosave>" + Ds.file_names[Ds.class_to_file_map[i]] + "</td><td>" + Ds.cl_names_class.cl_names[i] + "</td></tr>");
			}
		} percentage_of_classes = (count_of_covered * 100) / Ds.number_of_classes;
		html_writer.write("</table>");
		html_writer.write("<p>Class Coverege Achieved is " + percentage_of_classes + "%");
		report_writer.write("CLASS COVERAGE ACHIEVED = " + percentage_of_classes + "%\n");
		report_writer.write("---------------------------------------\n");
		writer3.write("% " + (new Integer(percentage_of_classes).toString()));
		writer3.close();
	}
	private static void print_branch_cvg_information() throws IOException {
		int current_file_no, prev_line_count;
		FileWriter writer1 = null;
		html_writer. write("<p><u>Branch Coverage Achieved</u><br>&nbsp;");
		html_writer. write("<table border cols=3 width = \"100%\" nosave>");
		html_writer. write("<tr align = center nosave><td nosave><b>File Name</b></td><td><b>Line numbers of branches not covered</b></td><td><b>Type of Branch</b></td></tr>");
		report_writer. write("---------------------------------------\n");
		report_writer. write("        FILE      Branches not covered\n");
		writer1 = new FileWriter("branches_history.dat", true);
		writer1.write("\n:::::\n");
		int count_of_not_covered = 0;
		for (int i = 0; i < Ds.total_number_of_branches; i++) {
			current_file_no = Ds.class_to_file_map[Ds.fn_blocks_class.fn_blocks[Ds.branch_to_fn_map_class.branch_to_fn_map[i]][2]];
			prev_line_count = current_file_no - 1 == -1 ? 0 : Ds.file_linenos[current_file_no - 1];
			if (Ds.branch_cvg_flags[i])
				writer1.write(" " + i + " ");
			if (Ds.branch_cvg_flags[i] == false && Ds.temp_branch_cvg_flags[i] == false) {
				count_of_not_covered++;
				if (Ds.fn_flags[Ds.branch_to_fn_map_class.branch_to_fn_map[i]] == true || Ds.temp_fn_flags[Ds.branch_to_fn_map_class.branch_to_fn_map[i]] == true) {
					html_writer.write("<tr align = center nosave><td nosave>" + Ds.file_names[current_file_no] + "</td><td>" + (Ds.branch_cvg_lineno_class.branch_cvg_lineno[i] - prev_line_count) + "</td><td>");
					report_writer.write("    " + Ds.file_names[current_file_no]
							    + "     " + (Ds.branch_cvg_lineno_class.branch_cvg_lineno[i] - prev_line_count));
					switch (Ds.branch_cvg_flags_class.branch_cvg_types[i]) {
					case 1: report_writer.write("  TRUE\n");
						html_writer.write("true</td></tr>");
						break;
					case 2: report_writer.write("  FALSE\n");
						html_writer.write("false</td></tr>");
						break;
					case 3: report_writer.write("  BRANCH\n");
						html_writer.write("case/default statement</td></tr>");
						break;
					case 4: report_writer.write("  CATCH_FIN_EX\n");
						html_writer.write("catch/finally statement</td></tr>");
						break;
					default:report_writer.write("  ERROR\n");
						break;
					}
				}
			}
		} 
		html_writer.write("</table>");
		int temp_total_number_of_branches = (Ds.total_number_of_branches == 0 ? 1 : Ds.total_number_of_branches);
		html_writer.write("<p>Branch Coverage Achieved is " + (100 - (100 * count_of_not_covered) / temp_total_number_of_branches) + "%");
		report_writer.write("BRANCH COVERAGE ACHIEVED = " + (100 - (100 * count_of_not_covered) / temp_total_number_of_branches) + "%\n");
		writer1.write("  % " + (100 - (100 * count_of_not_covered) / temp_total_number_of_branches));
		writer1.close();
	}
	private static void read_history_for_block_coverage() throws IOException {
		File file1 = new File("block_history.dat");
		FileReader reader1 = null;
		reader1 = new FileReader(file1);
		int counter = 0;
		char[] ch = new char[(int) file1.length()];
		reader1.read(ch);
		String s = new String(ch);
		StringTokenizer st = new StringTokenizer(s);
		if (st.hasMoreTokens() == false)
			 return;
		while (st.hasMoreTokens()) {
			String token = st.nextToken();
			if (token.compareTo(":::::") == 0)
				 counter++;
			else if (token.compareTo("%") == 0)
				 l_block.add((Object) st.nextToken());
			else if (token.compareTo("/") == 0)
				 l_time.add((Object) st.nextToken());
			else

				 Ds.temp_block_flags[(new Integer(token).intValue())] = true;
		} 
		reader1.close();
	}
	private static void read_history_coverage(String FileName, LinkedList l, boolean[]flags) throws IOException {
		File file1 = new File(FileName);
		FileReader reader1 = null;
		reader1 = new FileReader(file1);
		int counter = 0;
		char[] ch = new char[(int) file1.length()];
		reader1.read(ch);
		String s = new String(ch);
		StringTokenizer st = new StringTokenizer(s);
		if (st.hasMoreTokens() == false)
			 return;
		while (st.hasMoreTokens()) {
			String token = st.nextToken();
			if (token.compareTo(":::::") == 0)
				 counter++;
			else if (token.compareTo("%") == 0)
				 l.add((Object) st.nextToken());
			else
				 flags[(new Integer(token).intValue())] = true;
		} 
		reader1.close();
	}
	private static void print_history() throws IOException { 
		report_writer. write("SESSION      STATEMENT CVG      BRANCH CVG    FUNCTION CVG    CLASS CVG     TIME \n");
		int counter = 1, size = l_branch.size();
		Object block1, branch1, func1, class1, time1;
		while (counter <= size) {
			block1 = l_block.get(counter - 1);
			branch1 = l_branch.get(counter - 1);
			func1 = l_func.get(counter - 1);
			class1 = l_class.get(counter - 1);
			time1 = l_time.get(counter - 1);
			report_writer.write("  " + counter + "           " + block1 + "              " + branch1 + "              " + func1 + "           " + class1 + "         " + time1 + "\n");
			html_writer.write("<tr align = center nosave><td nosave>" + counter + "</td><td>" + block1 + "</td><td>" + branch1 + "</td><td>" + func1 + "</td><td>" + class1 + "</td><td>" + time1 + "</td></tr>");
			counter++;
		} 
		html_writer.write("</table></center>");
		report_writer.write("------------------------------------------------------------------- \n");
	}
	public static void check_for_modifications() { 
		int i = 0;
		while (i < Ds.file_full_names.length) {
			File f = new File(Ds.file_full_names[i]);
			if (f.lastModified() / 1000 != Ds.mtime[i]) {
				System.out.println(" Sorry " + Ds.file_full_names[i] + " is modified. So, coverage information can not be obtained. ");
				System.exit(0);
			}
			i++;
		}
	}
}
